-- =====================================================================
-- Copyright © 2010-2012 by Cryptographic Engineering Research Group (CERG),
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- =====================================================================

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity ntz is 
generic( G_MAX_LEN: integer:= 32; 
		   G_INDEX_WIDTH: integer:= 3);
port(
	address			: in std_logic_vector(G_MAX_LEN - 5 - 1 downto 0);
  	--output			: out std_logic_vector(2 downto 0));
	output			: out std_logic_vector(G_INDEX_WIDTH - 1 downto 0));

end ntz;

architecture functional of ntz is

    function ntz_lookup ( x: std_logic_vector; size: integer )
        return std_logic_vector is
            variable output : std_logic_vector(size-1 downto 0);
    begin
        output := std_logic_vector(to_unsigned(0, size));
        for i in x'low to x'high loop
            if x(i) = '0' then
                output := std_logic_vector(unsigned(output) + 1);
            else
                return output;
            end if;
        end loop;
        return output;
    end function ntz_lookup;

signal o: std_logic_vector(G_MAX_LEN - 5 - 1 downto 0);
	
begin	   
	
	o <= ntz_lookup(address, G_MAX_LEN - 5);
	output <= o(G_INDEX_WIDTH - 1 downto 0);
	
end functional;
